.386
.model flat,stdcall
option casemap:none

include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\shell32.inc
include \masm32\include\wsock32.inc

includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\shell32.lib
includelib \masm32\lib\wsock32.lib

WM_SHELLNOTIFY equ WM_USER+5
IDI_TRAY       equ 0
IDM_REFRESH    equ 1000
IDM_MESSAGE    equ 1010
IDM_EXIT	   equ 1020
WinMain PROTO :DWORD,:DWORD,:DWORD,:DWORD

.data
ClassName 	      db "MyIPTrayWinClass",0
AppName  		db "MyIPTray",0
RefreshString     db "&Recheck IP(s)",0
MessageString	db "&MessageBox",0
ExitString	 	db "E&xit Program",0
szTipMsg          db "Click for IP address(es)",0
hInstance	dd ?
hPopupMenu	dd ?
note        NOTIFYICONDATA <>
Buffer      db 256 dup (?)
WSAData     WSADATA <>
HostMsg     db "Click",13
HostAddr    db 256 dup (?)
HostName    db 256 dup (?)
edy         dd ?
esy         dd ?
ecy         dd ?

 ; HostName          db "ComputerABC",0
 ; HostAddr          db "192.168.0.1",13,10         ; IPAddress
 ;                   db "192.168.0.3",13,10
 ;                   db "192.168.0.5",13,10
 ;                   db "192.168.0.7",0

.code
start:
	invoke GetModuleHandle, NULL
	mov    hInstance,eax

      invoke WSAStartup, 101h,ADDR WSAData
      or eax,eax
      jnz @sockerrInit
  
      invoke gethostname, ADDR HostName,SIZEOF HostName
      or eax,eax
      jnz @nameerrInit

      invoke gethostbyname, ADDR HostName
      or eax,eax
      jz @nonameInit

      push edi
      push esi
      mov edi,OFFSET HostAddr
      mov eax,[eax+12] ;;hostent.h_list
      mov edx,eax
    @7:
      mov eax,[edx]
      or eax,eax
      jz @showInit
      mov eax,[eax]
      push edx
      invoke inet_ntoa, eax
      mov esi,eax
    @@:
      mov al,[esi]
      mov [edi],al
      inc edi
      inc esi
      or al,al
      jnz @B
      dec edi
      mov BYTE PTR[edi],13
      inc edi
      pop edx
      add edx,4
      jmp @7
  
    @showInit:
      dec edi
      mov [edi],al ;since jmp was because eax==0
      pop esi
      pop edi

      invoke WSACleanup

    @sockerrInit:
    @nameerrInit:
    @nonameInit:

	invoke WinMain, hInstance,NULL,NULL, SW_SHOWDEFAULT
	invoke ExitProcess,eax


WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL hwnd:HWND
	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW or CS_DBLCLKS
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
	push  hInst
	pop   wc.hInstance
	mov   wc.hbrBackground,COLOR_APPWORKSPACE
	mov   wc.lpszMenuName,NULL
	mov   wc.lpszClassName,OFFSET ClassName
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov   wc.hIcon,eax
	mov   wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov   wc.hCursor,eax
	invoke RegisterClassEx, addr wc

	invoke CreateWindowEx,WS_EX_CLIENTEDGE,ADDR ClassName,ADDR AppName,\
           WS_OVERLAPPED+WS_CAPTION+WS_SYSMENU+WS_MINIMIZEBOX+WS_MAXIMIZEBOX+WS_VISIBLE+WS_MINIMIZE,\
           CW_USEDEFAULT,CW_USEDEFAULT,350,200,NULL,NULL,\
           hInst,NULL
	mov   hwnd,eax
	.while TRUE
		invoke GetMessage, ADDR msg,NULL,0,0
		.BREAK .IF (!eax)
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.endw
	mov eax,msg.wParam
	ret
WinMain endp

WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL pt:POINT
	.if uMsg==WM_CREATE
		invoke CreatePopupMenu
		mov hPopupMenu,eax
		invoke AppendMenu,hPopupMenu,MF_STRING,IDM_REFRESH,addr RefreshString
		invoke AppendMenu,hPopupMenu,MF_STRING,IDM_MESSAGE,addr MessageString
		invoke AppendMenu,hPopupMenu,MF_STRING,IDM_EXIT,   addr ExitString
	.elseif uMsg==WM_DESTROY
		invoke PostQuitMessage,NULL
	.elseif uMsg==WM_SIZE
		.if wParam==SIZE_MINIMIZED
			mov note.cbSize,sizeof NOTIFYICONDATA
			push hWnd
			pop note.hwnd
			mov note.uID,IDI_TRAY
			mov note.uFlags,NIF_ICON+NIF_MESSAGE+NIF_TIP
			mov note.uCallbackMessage,WM_SHELLNOTIFY
			invoke LoadIcon,NULL,IDI_WINLOGO
			mov note.hIcon,eax
			invoke lstrcpy,addr note.szTip,addr HostMsg   ; HostAdrr  szTipMsg
			invoke ShowWindow,hWnd,SW_HIDE
			invoke Shell_NotifyIcon,NIM_ADD,addr note
		.endif
	.elseif uMsg==WM_COMMAND
		.if lParam==0
			; invoke Shell_NotifyIcon,NIM_DELETE,addr note
			mov eax,wParam
			.if ax==IDM_MESSAGE || ax==IDM_REFRESH

                        invoke WSAStartup, 101h,ADDR WSAData
                        or eax,eax
                        jnz @sockerr
                    
                        invoke gethostname, ADDR HostName,SIZEOF HostName
                        or eax,eax
                        jnz @nameerr
                    
                        invoke gethostbyname, ADDR HostName
                        or eax,eax
                        jz @noname

                        push edi
                        push esi
                        mov edi,OFFSET HostAddr
                        mov eax,[eax+12] ;;hostent.h_list
                        mov edx,eax
                      @1:
                        mov eax,[edx]
                        or eax,eax
                        jz @show
                        mov eax,[eax]
                        push edx
                        invoke inet_ntoa, eax
                        mov esi,eax
                      @@:
                        mov al,[esi]
                        mov [edi],al
                        inc edi
                        inc esi
                        or al,al
                        jnz @B
                        dec edi
                        mov BYTE PTR[edi],13
                        inc edi
                        pop edx
                        add edx,4
                        jmp @1
                    
                      @show:
                        dec edi
                        mov [edi],al ;since jmp was because eax==0
                        pop esi
                        pop edi

                        invoke WSACleanup

                   @sockerr:
                   @nameerr:
                   @noname:
                   Past:
                        mov ecy, ecx
                        mov esy, esi
                        mov edy, edi
                        mov ecx, 64
                        mov esi, OFFSET HostMsg         ; mov edi, OFFSET HostAddr
                        mov edi, OFFSET note.szTip
                      @@:
                        sub ecx, 4
                        mov eax, [esi+ecx]
                        mov [edi+ecx], eax
                        or  ecx,ecx
                        jnz @B
                        mov edi, edy
                        mov esi, esy
                        mov ecx, ecy

            	      invoke Shell_NotifyIcon,NIM_MODIFY,addr note

                        mov eax,wParam
                        .if ax==IDM_MESSAGE
                           invoke MessageBox,NULL,ADDR HostAddr,ADDR HostName,\
                                  MB_SETFOREGROUND+MB_SERVICE_NOTIFICATION+MB_TOPMOST+MB_OK
                        .endif
			.else
			    invoke Shell_NotifyIcon,NIM_DELETE,addr note				
                      invoke DestroyWindow,hWnd
			.endif
		.endif
 ; 	.elseif uMsg==WM_USER+5 ; to often             ; WM_MOUSEMOVE didn't work
 ; 
 ;             jmp @PastTip
 ; 
 ;             invoke WSAStartup, 101h,ADDR WSAData
 ;             or eax,eax
 ;             jnz @sockerrTip
 ;         
 ;             invoke gethostname, ADDR HostName,SIZEOF HostName
 ;             or eax,eax
 ;             jnz @nameerrTip
 ;         
 ;             invoke gethostbyname, ADDR HostName
 ;             or eax,eax
 ;             jz @nonameTip
 ; 
 ;             push edi
 ;             push esi
 ;             mov edi,OFFSET HostAddr
 ;             mov eax,[eax+12] ;;hostent.h_list
 ;             mov edx,eax
 ;           @2:
 ;             mov eax,[edx]
 ;             or eax,eax
 ;             jz @showTip
 ;             mov eax,[eax]
 ;             push edx
 ;             invoke inet_ntoa, eax
 ;             mov esi,eax
 ;           @@:
 ;             mov al,[esi]
 ;             mov [edi],al
 ;             inc edi
 ;             inc esi
 ;             or al,al
 ;             jnz @B
 ;             dec edi
 ;             mov BYTE PTR[edi],13
 ;             inc edi
 ;             pop edx
 ;             add edx,4
 ;             jmp @2
 ;         
 ;           @showTip:
 ;             dec edi
 ;             mov [edi],al ;since jmp was because eax==0
 ;             pop esi
 ;             pop edi
 ; 
 ;             invoke WSACleanup
 ; 
 ;        @sockerrTip:
 ;        @nameerrTip:
 ;        @nonameTip:
 ; 
 ;             mov ecy, ecx
 ;             mov esy, esi
 ;             mov edy, edi
 ;             mov ecx, 64                     ; 256
 ;             mov esi, OFFSET HostAddr        ; mov edi, OFFSET HostAddr
 ;             mov edi, OFFSET note.szTip      ; HostAddrDbg
 ;           @@:
 ;             sub ecx, 4
 ;             mov eax, [esi+ecx]
 ;             mov [edi+ecx], eax
 ;             or  ecx,ecx
 ;             jnz @B
 ;             mov edi, edy
 ;             mov esi, esy
 ;             mov ecx, ecy
 ; 
 ;        @PastTip:
 ; 	      invoke Shell_NotifyIcon,NIM_MODIFY,addr note

	.elseif uMsg==WM_SHELLNOTIFY
		.if wParam==IDI_TRAY
			.if lParam==WM_RBUTTONDOWN
				invoke GetCursorPos,addr pt
				invoke TrackPopupMenu,hPopupMenu,TPM_RIGHTALIGN,pt.x,pt.y,NULL,hWnd,NULL
			.elseif lParam==WM_LBUTTONUP
				invoke SendMessage,hWnd,WM_COMMAND,IDM_MESSAGE,0
			.elseif lParam==WM_LBUTTONDBLCLK
				invoke SendMessage,hWnd,WM_COMMAND,IDM_MESSAGE,0
                  ; maybe some message could be checked here causing a recheck of IP address(es)
			.endif
		.endif
	.else
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam		
		ret
	.endif
	xor eax,eax
	ret
WndProc endp

end start